<?php
// Database connection settings
$servername = "localhost";
$username = "reliableenterpri_pk";
$password = "gq;u[e]W=OR-";
$dbname = "reliableenterpri_kolkatacity";

// Create connection
$conn = new mysqli($servername, $username, $password, $dbname);

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Directory to store uploaded images
$uploadDir = 'uploads/';

// Ensure directory exists
if (!is_dir($uploadDir)) {
    mkdir($uploadDir, 0755, true);
}

// Function to convert image to WebP format
function convertToWebp($sourcePath, $targetPath, $quality = 80) {
    $imageType = exif_imagetype($sourcePath);
    switch ($imageType) {
        case IMAGETYPE_JPEG:
            $image = imagecreatefromjpeg($sourcePath);
            break;
        case IMAGETYPE_PNG:
            $image = imagecreatefrompng($sourcePath);
            // Disable alpha blending to preserve transparency
            imagepalettetotruecolor($image);
            imagealphablending($image, true);
            imagesavealpha($image, true);
            break;
        case IMAGETYPE_WEBP:
            $image = imagecreatefromwebp($sourcePath);
            break;
        default:
            return false; // Unsupported file type
    }

    // Save image as WebP
    $result = imagewebp($image, $targetPath, $quality);
    imagedestroy($image);
    return $result;
}

// Check if file is uploaded
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_FILES['image'])) {
    $image = $_FILES['image'];
    $heading = $_POST['heading'];
    $type = $_POST['type'];

    // Validate file type and size
    $allowedTypes = ['image/jpeg', 'image/png', 'image/webp'];
    if (in_array($image['type'], $allowedTypes) && $image['size'] < 5000000) { // 5MB max
        // Generate unique file name with .webp extension
        $imageName = uniqid() . '.webp';
        $targetPath = $uploadDir . $imageName;

        // Convert image to WebP and save
        if (convertToWebp($image['tmp_name'], $targetPath)) {
            // Insert file information into database
            $stmt = $conn->prepare("INSERT INTO gallery_photo (img, heading, type) VALUES (?, ?, ?)");
            $stmt->bind_param("sss", $imageName, $heading, $type);

            if ($stmt->execute()) {
                echo "Image uploaded and converted to WebP successfully.";
            } else {
                echo "Error: " . $stmt->error;
            }
            $stmt->close();
        } else {
            echo "Failed to convert image to WebP format.";
        }
    } else {
        echo "Invalid file type or size. Only JPEG, PNG, and WebP files under 5MB are allowed.";
    }
} else {
    echo "No file uploaded.";
}

$conn->close();
?>
